!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Program Arare
!
!   * Developer: SUGIYAMA Ko-ichiro 
!   * Version: $ 
!   * Tag Name: $Name: arare3-20051019 $
!   * Change History: 
!
!== Overview 
!
! ϳإǥ deepconv/arare. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ϤϽవ̷.
!
!== Future Plans
!
                                                                 !=end
!-- (2005/04/21 ) --
! Ūʥ
! - ץΤήϤǤ褤Ȼפ.
! - ̿̾ˡ(³̾, ѿ, )ϸƤ;Ϥ
! - ʸɤٽ񤭹फ?
!   arare.f90 饳ɲΡ֥ᥤץήפư
!   褦ˤʤäƤȤ褤. 
!  

program arare
                                                                 !=begin
  !== Dependency
    !-- (2005/04/21 ) --
    ! use ѿˤ⥳Ȥդۤ褤Ȼפ, 뤵? 
    ! Ȥϳƥ֥롼/⥸塼εҤȰפ.
    !
  use dc_trace, only: BeginSub, &      ! ǥХåϥ֥롼  
       &              EndSub,   &      ! ǥХåϥ֥롼  
       &              DbgMessage       ! ǥХåϥ֥롼  
  use dc_message                       ! only ° ?
  use fileset,  only: fileset_init,  & ! I/O ե֥̾롼  
       &              cfgfile,       & ! ե
       &              ReStartFile,   & ! ѥꥹȥե
       &              NewReStartFile   ! ѥꥹȥե
  use debugset, only: debugset_init, & ! ǥХå֥롼
       &              DebugOn          ! ǥХåϥå
  use gridset,  only: gridset_init,  & ! ʻ֥롼
       &              DimXMin,       & ! x β 
       &              DimXMax,       & ! x ξ
       &              DimZMin,       & ! z β
       &              DimZMax,       & ! z ξ
       &              RegZMin,       & ! z ʪΰβ
       &              RegZMax          ! z ʪΰξ 
  use timeset,  only: timeset_init,  & ! ʬ֥롼
       &              NstepShort,    & ! ĹॹƥåפΥƥå׿
       &              NstepLong,     & ! ûॹƥåפΥƥå׿
       &              DelTimeShort,  & ! Ĺॹƥå
       &              DelTimeLong,   & ! ûॹƥå
       &              TimeDisp         ! եϤֳִ
  use nameset,  only: nameset_init     ! ¸֥̾롼
  use physset,  only: physset_init     ! ʪν֥롼
  use linlib,   only: linlib_init      ! ׻饤֥֥롼
  use bcset,    only: bcset_init       ! ꥵ֥롼
  use basicset, only: basicset_file_init ! ܾꥵ֥롼
  use arareset, only: arareset_init    ! ׻ɤ߹ॵ֥롼
                                                                 !=end
  !== ۤηػ
  implicit none

  !== 
  real(8), allocatable  :: fs_VelX_as(:,:)    ! ʿ®      [t=(n-1)]
  real(8), allocatable  :: fs_VelX_ns(:,:)    ! ʿ®      [t=n]
  real(8), allocatable  :: sf_VelZ_as(:,:)    ! ľ®      [t=(n-1)]
  real(8), allocatable  :: sf_VelZ_ns(:,:)    ! ľ®      [t=n]
  real(8), allocatable  :: ss_Exner_ns(:,:)   ! ʡؿ[t=n]
  real(8), allocatable  :: ss_Exner_as(:,:)   ! ʡؿ[t=(n-1)]

  real(8), allocatable  :: ss_PotTemp_bl(:,:) !  [t=(n-1)t]
  real(8), allocatable  :: ss_PotTemp_nl(:,:) !  [t=nt    ]
  real(8), allocatable  :: ss_PotTemp_al(:,:) !  [t=(n+1)t]
  real(8), allocatable  :: ss_Exner_bl(:,:)   ! ʡؿ [t=(n-1)t]
  real(8), allocatable  :: ss_Exner_nl(:,:)   ! ʡؿ [t=nt    ]
  real(8), allocatable  :: ss_Exner_al(:,:)   ! ʡؿ [t=(n+1)t]
  real(8), allocatable  :: fs_VelX_bl(:,:)    ! ʿ® [t=(n-1)t]
  real(8), allocatable  :: fs_VelX_nl(:,:)    ! ʿ® [t=nt    ]
  real(8), allocatable  :: fs_VelX_al(:,:)    ! ʿ® [t=(n+1)t]
  real(8), allocatable  :: sf_VelZ_bl(:,:)    ! ľ® [t=(n-1)t]
  real(8), allocatable  :: sf_VelZ_nl(:,:)    ! ľ® [t=nt    ]
  real(8), allocatable  :: sf_VelZ_al(:,:)    ! ľ® [t=(n+1)t]

  real(8), allocatable  :: fs_AdvDiffX_nl(:,:)! ʿαưΰήȳȻ   [t=nt]
  real(8), allocatable  :: sf_AdvDiffZ_nl(:,:)! ľαưΰήȳȻ   [t=nt]
  
  real(8), allocatable  :: ss_Km_bl(:,:)      ! Ǵ [t=(n-1)t]
  real(8), allocatable  :: ss_Km_nl(:,:)      ! Ǵ [t=nt    ]
  real(8), allocatable  :: ss_Km_al(:,:)      ! Ǵ [t=(n+1)t]
  real(8), allocatable  :: ss_Kh_bl(:,:)      ! Ȼ [t=(n-1)t]
  real(8), allocatable  :: ss_Kh_nl(:,:)      ! Ȼ [t=nt    ]
  real(8), allocatable  :: ss_Kh_al(:,:)      ! Ȼ [t=(n+1)t]

  real(8)               :: Time               ! ׻³
  real(8)               :: DelTime            ! ֥ƥå
  real(8)               :: ReStartTime(2)     ! ꥹȥեλ
  integer               :: t, tau             ! 롼פ󤹤ѿ
  integer               :: NStep_leapfrog     ! 롼פ󤹲


  
!== 
  
  !=== I/O ե̾ν
  !NAMELIST ե̾ꤷ, deepconv/arare 
  !ϥե̾ NAMELIST 
  call fileset_init

  !=== ǥХν
  !NAMELIST , ǥХåϥåؤԤ.  
  call debugset_init(cfgfile)

  !=== ʻν
  !NAMELIST , ʻ׻
  call gridset_init(cfgfile)
  
  !=== ʬν
  !NAMELIST ɬפʾɤ߼, ִϢѿԤ. 
  call timeset_init(cfgfile)
  
  !=== ¸̾ν
  !netCDF ˽񤭹¸̾ NAMELIST ɤ߹
  call nameset_init(cfgfile)
  
  !=== ʪν
  !NAMELIST ʪɤ߹
  call physset_init(cfgfile)
  
  !=== ׻ɤ߹
  !NameList ե뤫 arare ¹Ԥɬפʥѥ᥿
  call arareset_init(cfgfile)

  !=== 
  !NAMELIST 鶭Υפꤹ. 
  call bcset_init(cfgfile)

  !=== ϥե
  call OpenDataFile


!== ѿν

  !=== γ, 
  call ArareAlloc

  !=== ܾͤ
  !ܾͤ netCDF ե뤫. 
  call basicset_file_init( ReStartFile )

  !=== ͤ
  !νͤ netCDF ե뤫. 
  call getdisturbvar( ReStartFile, ReStartTime,   &
       & fs_VelX_bl,     sf_VelZ_bl,  ss_Exner_bl,  &
       & ss_PotTemp_bl,  ss_Km_bl,    ss_Kh_bl,     &
       & fs_VelX_nl,     sf_VelZ_nl,  ss_Exner_nl,  &
       & ss_PotTemp_nl,  ss_Km_nl,    ss_Kh_nl      )

  !=== ׻饤֥ν. 
  !Ѥ׻ѥå NAMELIST ꤷ, 
  !礭ꤹ
  !  * ϥ顼 z η׻ΰ礭
  call linlib_init(cfgfile, RegZMax - RegZMin)

  !=== ν
  Time = ReStartTime(2)          !ꥹȳϻ
  DelTime = 2.0 * DelTimeLong    !leap-frog Ǥʬ

  !=== 롼ײν
  ! 0 äη׻, ʤ ReStartTime(1) = 0 Ǥ, 
  ! 0 äʬ TimeInt ޤʬ. 
  !ΤȤ leap-frog  NstepLong - 1 롼פ뤳ȤȤʤ. 
  !
  !³׻, ʤ ReStartTime(1) /= 0 Ǥ, 
  !RestartTime(2) äʬ TimeInt ޤʬ. 
  !ΤȤ leap-frog  NstepLong1 롼פ뤳ȤȤʤ. 
  !³׻ξˤϥꥹȥեλ狼׻ԤǤ.

  if ( ReStartTime(1) == 0.0 ) then 
     Nstep_leapfrog = NstepLong - 1
  else
     Nstep_leapfrog = NstepLong
  end if

  !===  0 η׻Ǥ, ɬפ˱ƽͤե
  if ( ReStartTime(1) == 0.0 ) then 
     call OutputDataFile( ReStartTime(1), &
          & fs_VelX_bl, sf_VelZ_bl, ss_Exner_bl, &
          & ss_PotTemp_bl, ss_Km_bl, ss_Kh_bl )

     if ( mod( ReStartTime(2), TimeDisp ) == 0 ) then 
        call OutputDataFile( ReStartTime(2), &
             & fs_VelX_nl, sf_VelZ_nl, ss_Exner_nl, &
             & ss_PotTemp_nl, ss_Km_nl, ss_Kh_nl )
     end if
  end if


!== CFL Υå

  call cflcheck


!== Ĺ֥ƥå. leap-frog 
  do t = 1, Nstep_leapfrog
     Time = Time + DelTimeLong
     write(*,*) Time

     !=== Ǵ, Ȼη׻
     call EddyViscosity(                                     &
          & ss_Km_bl,                                        & 
          & DelTime,                                         & !ֳִ
          & fs_VelX_nl, sf_VelZ_nl, ss_Km_nl,                & !ή
          & fs_VelX_bl, sf_VelZ_bl, ss_PotTemp_bl, ss_Km_bl, & !Ȼ
          & ss_Km_al, ss_Kh_al )

     !=== Ĺ֥ƥåפǤβ̤η׻
     call Scalar(                                   & 
          & ss_PotTemp_bl,                          &
          & DelTime,                                & !ֳִ
          & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl,  & !ή
          & ss_PotTemp_bl, ss_Kh_bl,                & !ήȻ, 
          & ss_PotTemp_al)
     
     !=== Ĺ֥ƥåפǤ® u ΰή, Ȼ, Ǵ
     call AdvectDiffuseX(                     &
          & fs_VelX_nl, sf_VelZ_nl,           & !ή
          & fs_VelX_bl, sf_VelZ_bl, ss_Km_bl, & !ήȻ, Ǵ
          & fs_AdvDiffX_nl )

     !=== Ĺ֥ƥåפǤ® w ΰή, Ȼ, Ǵ
     call AdvectDiffuseZ(                          &
          & fs_VelX_nl, sf_VelZ_nl, ss_PotTemp_nl, & !ή, 
          & fs_VelX_bl, sf_VelZ_bl, ss_Km_bl,      & !ήȻ, Ǵ
          & sf_AdvDiffZ_nl )
     
     !=== ûॹƥåפνͤ
     fs_VelX_ns  = fs_VelX_bl
     sf_VelZ_ns  = sf_VelZ_bl
     ss_Exner_ns = ss_Exner_bl 
     
     !=== ûॹƥåפǤʬ
     do tau = 1, NstepShort 
        !==== ® u η׻
        call VelocityX(                                             &
             & fs_VelX_ns,                                          &
             & DelTimeShort,                                        &
             & fs_AdvDiffX_nl, fs_VelX_ns, sf_VelZ_ns, ss_Exner_ns, &
             & fs_VelX_as )
        
        !==== ʡؿη׻
        call Exner(                                    &
             & sf_AdvDiffZ_nl, fs_VelX_ns, fs_VelX_as, &
             &   sf_VelZ_ns, ss_Exner_ns,              &
             & ss_Exner_as )

        !==== ® w η׻
        call VelocityZ(                                &
             & sf_VelZ_ns,                             &
             & DelTimeShort,                           &
             & sf_AdvDiffZ_nl, fs_VelX_ns, sf_VelZ_ns, &
             &    ss_Exner_ns, ss_Exner_as,            &
             & sf_VelZ_as )
        
        !==== û֥ƥåפΥ롼פ󤹤ν
        ss_Exner_ns  = ss_Exner_as 
        fs_VelX_ns   = fs_VelX_as
        sf_VelZ_ns   = sf_VelZ_as
        
     end do
     
     !=== ǽŪû֥ƥåפǤͤĹ֥ƥåפǤͤȤߤʤ
     ss_Exner_al  = ss_Exner_as 
     fs_VelX_al   = fs_VelX_as
     sf_VelZ_al   = sf_VelZ_as     
     
     !=== åλ֥ե륿
     call AsselinTimeFilter(ss_PotTemp_al, ss_PotTemp_nl, ss_PotTemp_bl )
     call AsselinTimeFilter(ss_Exner_al,   ss_Exner_nl,   ss_Exner_bl )
     call AsselinTimeFilter(fs_VelX_al,    fs_VelX_nl,    fs_VelX_bl )
     call AsselinTimeFilter(sf_VelZ_al,    sf_VelZ_nl,    sf_VelZ_bl )

     !=== Ĺ֥ƥåפΥ롼פ󤹤ν
     ss_PotTemp_bl = ss_PotTemp_nl
     ss_Exner_bl   = ss_Exner_nl 
     fs_VelX_bl    = fs_VelX_nl
     sf_VelZ_bl    = sf_VelZ_nl
     ss_Km_bl      = ss_Km_nl
     ss_Kh_bl      = ss_Kh_nl
     ss_PotTemp_nl = ss_PotTemp_al
     ss_Exner_nl   = ss_Exner_al 
     fs_VelX_nl    = fs_VelX_al
     sf_VelZ_nl    = sf_VelZ_al
     ss_Km_nl      = ss_Km_al
     ss_Kh_nl      = ss_Kh_al

     !=== ե
     if ( mod( Time, TimeDisp ) == 0 ) then 
        call DbgMessage(fmt="Time = %f", d=(/Time/))
        call OutputDataFile( Time, &
             &  fs_VelX_nl,    sf_VelZ_nl, ss_Exner_nl, &
             &  ss_PotTemp_nl, ss_Km_nl,   ss_Kh_nl )
     end if
     
  end do
  
  !=== ϥեΥ
  call CloseDataFile

  !=== ꥹȥեκ
  ReStartTime(1) = Time - DelTimeLong
  ReStartTime(2) = Time
  call MakeReStartFile( NewReStartFile, ReStartTime, &
       & fs_VelX_bl,    sf_VelZ_bl,  ss_Exner_bl,    &
       & ss_PotTemp_bl, ss_Km_bl,    ss_Kh_bl,       &
       & fs_VelX_nl,    sf_VelZ_nl,  ss_Exner_nl,    &
       & ss_PotTemp_nl, ss_Km_nl,    ss_Kh_nl        )

contains

!!!
!!!γ, 
!!!
  subroutine ArareAlloc

    call BeginSub("ArareAlloc", &
&                 fmt="%c",     &
&                 c1="Allocate and initialize allocatable variables.")

    allocate(ss_Exner_as(DimXMin:DimXMax, DimZMin:DimZMax),  &
         & fs_VelX_as(DimXMin:DimXMax, DimZMin:DimZMax)  , &
         & sf_VelZ_as(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_ns(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_VelX_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_VelZ_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Exner_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_PotTemp_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & fs_AdvDiffX_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & sf_AdvDiffZ_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Km_al(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_bl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_nl(DimXMin:DimXMax, DimZMin:DimZMax), &
         & ss_Kh_al(DimXMin:DimXMax, DimZMin:DimZMax) )

    fs_VelX_al = 0.0d0
    fs_VelX_nl = 0.0d0
    fs_VelX_bl = 0.0d0

    sf_VelZ_al = 0.0d0
    sf_VelZ_nl = 0.0d0
    sf_VelZ_bl = 0.0d0

    ss_Exner_al = 0.0d0
    ss_Exner_nl = 0.0d0
    ss_Exner_bl = 0.0d0
    
    ss_PotTemp_al = 0.0d0
    ss_PotTemp_nl = 0.0d0
    ss_PotTemp_bl = 0.0d0

    fs_VelX_as = 0.0d0
    fs_VelX_ns = 0.0d0

    sf_VelZ_as = 0.0d0
    sf_VelZ_ns = 0.0d0

    ss_Exner_as = 0.0d0
    ss_Exner_ns = 0.0d0

    fs_AdvDiffX_nl = 0.0d0
    sf_AdvDiffZ_nl = 0.0d0

    ss_Km_bl = 0.0d0
    ss_Km_nl = 0.0d0
    ss_Km_al = 0.0d0
    ss_Kh_bl = 0.0d0
    ss_Kh_nl = 0.0d0
    ss_Kh_al = 0.0d0

    Time = 0.0d0

    call EndSub("ArareAlloc")

  end subroutine ArareAlloc

end program arare

